
//

#version 3.6;

#include "colors.inc"

global_settings {
  assumed_gamma 1.0
}

// ----------------------------------------
//-------------------------------------------Jeux de cameras produits par Eloi Simard------------------------------ 





    //============Cette section sert a programmer plusieurs mouvements d'un seul coup
    // Les variable TempsX coupent le temps en 5 etapes allant de 0 a 1
    //Attention: Pour avoir un dplacement fluide, il faut que le camera2 et lookat2 du temps 1 sioent les meme que les cam1 et look1 du temps 2, etc.
    //Utilisez les parametres du temps 1 s'il n y a pas d animation (clock=0) 
    
#declare Temps1= .3;
#declare Temps2= .5;
#declare Temps3= .7;
#declare Temps4= .9;


#if(clock <= Temps1)
		#declare positioncamera1 = <60,10,60>;
		#declare positioncamera2 = <0,20,0>;
		#declare LookAt1 = <0,10,0> ;
		#declare LookAt2 = <0,40,0>;
	#declare Relativeclock= clock/(Temps1);
#else  //else1
	
	#if (clock<= Temps2)
	#declare positioncamera1 = <0,20,0>;
	#declare positioncamera2 = <5,26,0>;
	#declare LookAt1 = <0,40,0> ;
	#declare LookAt2 = <10,26,0>;
	#declare Relativeclock=(clock -Temps1) /(Temps2-Temps1);
	#else //else2
		
		#if (clock<= Temps3)
		#declare positioncamera1 = <5,26,0>;
		#declare positioncamera2 = <21,26,0>;
		#declare LookAt1 = <10,26,0> ;
		#declare LookAt2 = <21,26,1>;
		
		#declare Relativeclock= (clock-Temps2)/(Temps3-Temps2);
		#else //else3
			#if (clock<= Temps4)
			#declare positioncamera1 = <21,26,0>;
			#declare positioncamera2 = <21,26,3>;
			#declare LookAt1 = <21,26,1> ;
			#declare LookAt2 = <21,27,3>;     
			#declare Relativeclock= (clock-Temps3)/(Temps4-Temps3);
			#else //else4
			
				#if (clock<= 1)
				#declare positioncamera1 = <21,26,3>;
				#declare positioncamera2 = <21,26,-3>;
				#declare LookAt1 = <21,27,3> ;
				#declare LookAt2 = <21,25,-3>;     
			       #declare Relativeclock= (clock-Temps4)/(1-Temps4);
			       #end		
			#end //end else4
		#end //3
	#end //2
#end //1

//=============================================================================


//variables apres calculs de video (le clock doit aller de 0 a 1
#declare PosCam= positioncamera1+Relativeclock*(positioncamera2-positioncamera1)   ;
#declare LookAt = LookAt1+ Relativeclock*(LookAt2 - LookAt1);





//    ---------------------------------------Fin des jeux de camras------------------------------------------------------------




//===========================================Dfinition du fractale
// l objet s appelle "etape" parce qu il faut donner le nombre de sous branches
// ainsi: etape(0) n'est qu'un tronc et  etape(7) possede 7 niveaux de branches en plus du tronc
//  Le principe: chaque tape est semblable a celle d'avant, mais plus petit et coller 5 fois sur le tronc




#declare Longueur=10 ; 
#declare Ratio=.6; // ici on peut brancher clock sur le ratio pour faire "pousser " le fractale


#declare Long=function {Longueur * pow(Ratio,x)+0*y+0*z};//cette fonction sert a savoir de combien translater les sous branches

#macro Etape(No)         //the real thing
#declare Lg=Long(No,0,0);  //Ainsi on peut utiliser Long(No,0,0) pour avoir la largeur de n<inporte quelle etape ou Lg pour l etape actuelle
#if (No<1)
        
        
        box { <-Longueur/2, 0, -Longueur/2>, <Longueur/2, 3*Longueur, Longueur/2>  

             
                 transform {
                                  scale 1.0
                                  rotate 0*z
                                  translate 0*x
                            }
                } 
   
#else        
union {       
        
        object { Etape(0) 
                  
                 transform {
                                  scale 1.0
                                  rotate 0*z
                                  translate 0*x
                            }
                }        

        object { Etape(No-1) 
                  
                 transform {
                                  scale Ratio
                                  rotate 90*x
                                  translate (2.9*Long(0,0,0)-Long(1,0,0)/2)*y
                                  translate z*(Long(0,0,0)/2.1)

                            }
                }        
                
        object { Etape(No-1) 
                    
                 transform {
                                  scale Ratio
                                  rotate -90*x
                                   translate (2.9*Long(0,0,0)-Long(1,0,0)/2)*y
                                  translate -z*(Long(0,0,0)/2.1)
                            }
                }                
         object { Etape(No-1) 
                  
                 transform {
                                  scale Ratio
                                  rotate 90*z
                                  translate (2.9*Long(0,0,0)-Long(1,0,0)/2)*y
                                  translate -x*(Long(0,0,0)/2.1)
                            }
                }        
                
        object { Etape(No-1) 
                    
                 transform {
                                  scale Ratio
                                  rotate -90*z
                                  translate (2.9*Long(0,0,0)-Long(1,0,0)/2)*y
                                  translate x*(Long(0,0,0)/2.1)
                            }
                }                
           object { Etape(No-1) 
                    
                 transform {
                                  scale Ratio
                                  
                                  translate (2.95*Long(0,0,0))*y
                                 
                            }
                }                
       pigment {color rgbt <1/No,No/5,0,0> }   //le tronc est vert et les branches de plus en plus orange
       } //fin de l union
     
#end //fin du while qui definit l etape 0    
#end//fin du macro        

 //----------------------------------------------fin des definitions d objets
 
 //----------------------------------scene

camera {       
  //orthographic
  //angle 50
  location  PosCam
  //direction 1.5*z
  right     x*image_width/image_height
  look_at  LookAt }

sky_sphere {
  pigment {
    gradient y
    color_map {
      [0.0 rgb <0.6,0.7,1.0>]
      [0.7 rgb <0.0,0.1,0.8>]
    }
  }
}

light_source {
  <0, 0, 0>            // light's position (translated below)
  color rgb <1, 1, 1>  // light's color
  translate <-30, 30, -30>
}


light_source {
  PosCam            // light's position (translated below)
  color rgb <1, 1, 1>  // light's color
 translate <25,5,5>
}
        
       
 
 // Une lumire spotlight pour donner l'impression qu'on se promene avec une lampe de poche
light_source {
  PosCam                     // light's position (translated below)
  color rgb <1,1,1>       // light's color
  spotlight               // this kind of light source
  translate <0, 0, -0> // <x y z> position of light
  point_at LookAt      // direction of spotlight
  radius 20                // hotspot (inner, in degrees)
  tightness 30           // tightness of falloff (1...100) lower is softer, higher is tighter
  falloff 90               // intensity falloff radius (outer, in degrees)
}
 
   
 
   // J'ai utilis diffrence pour m'assurer de pouvoir me promener a l'intrieur, malheureusement, cela ne fonctionne que dans les deux premires branches.  Plus profond, ca fait des trous dans les parois
difference {
  object {  Etape (3) } // Start with this shape
  object {  Etape (2)   scale .99*x scale .99*z translate 0*y} // This will be "cut out" of Shape1       */
}

         
         
         